"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useIsMobile = exports.default = void 0;
var _react = require("react");
var _nebenanEventproxy = _interopRequireDefault(require("nebenan-eventproxy"));
var _dom = require("nebenan-helpers/lib/dom");
var _utils = require("../utils");
var _jsxRuntime = require("react/jsx-runtime");
/**
 * @function useIsMobile
 * @description Subscription on Resize. See nebenan-helpers/lib/dom
 * @return {Boolean} isMobile
 */
const useIsMobile = () => {
  const [isMobile, setIsMobile] = (0, _react.useState)(null);
  (0, _react.useEffect)(() => {
    setIsMobile(!(0, _dom.getMedia)(window, _dom.media.mediaM));
    return (0, _nebenanEventproxy.default)('resize', () => setIsMobile(!(0, _dom.getMedia)(window, _dom.media.mediaM)));
  }, []);
  return isMobile;
};

/**
 * @param {React.Component} Component Target component
 * @param {Object} options
 * @return {React.Component} AdaptiveComponent
 */
exports.useIsMobile = useIsMobile;
const makeAdaptive = function (Component) {
  let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  const AdaptiveComponent = _ref => {
    let {
      forwardedRef,
      ...props
    } = _ref;
    const isMobile = useIsMobile();
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(Component, {
      ...props,
      ref: forwardedRef,
      mobile: isMobile
    });
  };
  const displayName = (0, _utils.getDisplayName)('makeAdaptive', Component);
  if (options.forwardRef) return (0, _utils.getForwardedComponent)(displayName, AdaptiveComponent);
  AdaptiveComponent.displayName = displayName;
  return AdaptiveComponent;
};
var _default = exports.default = makeAdaptive;