"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.historyPropTypes = exports.default = void 0;
var _react = require("react");
var _reactRouter = require("react-router");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _utils = require("../utils");
var _jsxRuntime = require("react/jsx-runtime");
/**
 * History HOC
 * @param {React.Component} Component Target component
 * @return {React.Component} Wrapped component
 */const withHistory = Component => {
  const displayName = (0, _utils.getDisplayName)('withHistory', Component);
  const WrappedComponent = (props, ref) => {
    const history = (0, _reactRouter.useHistory)();
    const location = (0, _reactRouter.useLocation)();
    const params = (0, _reactRouter.useParams)();
    const match = {
      params
    };
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(Component, {
      ...props,
      history: history,
      location: location,
      match: match,
      ref: ref
    });
  };
  WrappedComponent.displayName = displayName;
  WrappedComponent.WrappedComponent = Component;
  return /*#__PURE__*/(0, _react.forwardRef)(WrappedComponent);
};
var _default = exports.default = withHistory;
const historyPropTypes = exports.historyPropTypes = {
  history: _propTypes.default.object.isRequired,
  location: _propTypes.default.object.isRequired,
  match: _propTypes.default.object.isRequired,
  staticContext: _propTypes.default.object
};