"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _utils = require("../utils");
var _jsxRuntime = require("react/jsx-runtime");
/**
 * @param {string[]} methods
 * @param {React.Component} Component
 * @return {React.ForwardRefExoticComponent}
 */const mergeMethods = (methods, Component) => {
  const displayName = (0, _utils.getDisplayName)('mergeMethods', Component);
  const ProxyComponent = (props, ref) => {
    const selfRef = (0, _react.useRef)();
    const getHandle = name => function () {
      const {
        current: that
      } = selfRef;
      const instance = that[name] ? that : that.getNestedRef();
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return instance[name].call(instance, ...args);
    };
    (0, _react.useImperativeHandle)(ref, () => ({
      ...methods.reduce((acc, name) => ({
        ...acc,
        [name]: getHandle(name)
      }), {}),
      getRef: () => selfRef.current,
      getNestedRef: () => selfRef.current.getNestedRef()
    }));
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(Component, {
      ...props,
      ref: selfRef
    });
  };
  ProxyComponent.displayName = displayName;
  return /*#__PURE__*/(0, _react.forwardRef)(ProxyComponent);
};
var _default = exports.default = mergeMethods;
module.exports = exports.default;
module.exports.default = exports.default;