"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactRedux = require("react-redux");
var _utils = require("../utils");
/**
 * @param {function} mapStateToProps
 * @param {function} mapDispatchToProps
 * @param {object} mergeProps
 * @param {object} opts
 * @return { React.Component } Wrapped with Redux.Connect component
 */
const proxyConnect = (mapStateToProps, mapDispatchToProps, mergeProps, opts) => {
  const options = {
    ...opts,
    forwardRef: true
  };
  const connectFunc = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps, options);
  return Component => {
    const displayName = (0, _utils.getDisplayName)('proxyConnect', Component);
    const WrappedComponent = (0, _utils.getForwardedComponent)(displayName, Component);
    return connectFunc(WrappedComponent);
  };
};
var _default = exports.default = proxyConnect;
module.exports = exports.default;
module.exports.default = exports.default;