"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMergedRef = exports.default = void 0;
var _utils = require("../utils");
/**
 * @param {React.Component} Component
 * @return {React.ForwardRefExoticComponent}
 */
const proxyRef = Component => (0, _utils.getForwardedComponent)((0, _utils.getDisplayName)('proxyRef', Component), Component);

/**
 * @function
 * @param {React.RefObject} ref
 * @param {function} getterFn
 * @return {function}
 */
const getMergedRef = (ref, getterFn) => {
  // ref exists and created via createRef
  if (ref && typeof ref !== 'function') {
    getterFn(ref);
    return ref;
  }

  // ref doesn't exist or is a function
  return el => {
    getterFn({
      current: el
    });
    if (ref) ref(el);
  };
};
exports.getMergedRef = getMergedRef;
var _default = exports.default = proxyRef;