"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useShallowEqualSelector = exports.useActions = void 0;
var _react = require("react");
var _redux = require("redux");
var _reactRedux = require("react-redux");
/**
 * @function
 * @param actions {function | function[]} array of functions or one single function
 * @param {any[]} deps dependencies for useMemo
 * @return {function | function[]} array of functions or one single function wrapped with dispatch
 */
const useActions = (actions, deps) => {
  const dispatch = (0, _reactRedux.useDispatch)();
  return (0, _react.useMemo)(() => {
    if (Array.isArray(actions)) return actions.map(action => (0, _redux.bindActionCreators)(action, dispatch));
    return (0, _redux.bindActionCreators)(actions, dispatch);
  }, deps ? [dispatch, ...deps] : [dispatch]);
};
exports.useActions = useActions;
const useShallowEqualSelector = selector => (0, _reactRedux.useSelector)(selector, _reactRedux.shallowEqual);
exports.useShallowEqualSelector = useShallowEqualSelector;