"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _debounce = _interopRequireDefault(require("lodash/debounce"));
var _react = require("react");
/**
 * Note: Does not react to `delay` changes
 * @param {function} func Original function
 * @param {number} delay Delay in ms
 * @param {any[]} deps Dependencies array for useEffect
 * @return {function}
 */
const useDebouncedCallback = function (func, delay) {
  let deps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  const callback = (0, _react.useRef)(null);
  callback.current = func;
  const wrappedRef = (0, _react.useRef)(null);
  if (!wrappedRef.current) {
    wrappedRef.current = (0, _debounce.default)(function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return callback.current?.(...args);
    }, delay);
  }
  (0, _react.useEffect)(() => () => {
    wrappedRef.current?.cancel();
  }, [...deps]);
  return wrappedRef.current;
};
var _default = exports.default = useDebouncedCallback;
module.exports = exports.default;
module.exports.default = exports.default;