"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _use_stable_callback = _interopRequireDefault(require("../use_stable_callback"));
/**
 * @param {function} fn function to be called once
 * @param {any[]} resetDeps array of dependencies for resetting 'once' state
 * @returns {function} callback with stable identity
 */
const useOnceCallback = function (fn) {
  let resetDeps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  const wasCalledRef = (0, _react.useRef)(false);
  (0, _react.useEffect)(() => {
    wasCalledRef.current = false;
  }, resetDeps);
  return (0, _use_stable_callback.default)(function () {
    if (wasCalledRef.current) return;
    fn(...arguments);
    wasCalledRef.current = true;
  });
};
var _default = exports.default = useOnceCallback;
module.exports = exports.default;
module.exports.default = exports.default;