"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _use_mounted = _interopRequireDefault(require("../use_mounted"));
/**
 * @return {function(*): Promise<unknown>}
 */
const usePromiseGuard = () => {
  const isMounted = (0, _use_mounted.default)();
  return (0, _react.useCallback)(getPromise => new Promise((resolve, reject) => {
    getPromise().then(result => {
      if (isMounted.current) resolve(result);
    }).catch(result => {
      if (isMounted.current) reject(result);
    });
  }), []);
};
var _default = exports.default = usePromiseGuard;
module.exports = exports.default;
module.exports.default = exports.default;