"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
/**
 * @param {Number} timeout Timeout for setTimeout in ms
 * @return {Array<boolean, function>} Current status and Toggle function
 */
const useResettingVisibility = timeout => {
  const [isVisible, setVisibility] = (0, _react.useState)(false);
  (0, _react.useEffect)(() => {
    if (!isVisible) return;
    const timer = setTimeout(setVisibility.bind(undefined, false), timeout);
    return () => clearTimeout(timer);
  }, [isVisible]);
  return [isVisible, setVisibility];
};
var _default = exports.default = useResettingVisibility;
module.exports = exports.default;
module.exports.default = exports.default;