"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactRouter = require("react-router");
var _routes = require("nebenan-helpers/lib/routes");
var _react = require("react");
/**
 * @param {function} callback
 * @return {function}
 */
const useSmartClickHandler = callback => {
  const history = (0, _reactRouter.useHistory)();
  return (0, _react.useCallback)(event => {
    const {
      target
    } = event;
    const href = target.getAttribute('href');
    const isLink = target.tagName === 'A';
    if (isLink && href) {
      event.preventDefault();
      const isSameDomain = href.startsWith(global.location.origin);
      const path = (0, _routes.stripOriginFromUrl)(href, global.location.origin);
      if (isSameDomain) history.push(path);else global.open(href, undefined, 'noopener noreferrer');
      return;
    }
    callback();
  }, [history, callback]);
};
var _default = exports.default = useSmartClickHandler;
module.exports = exports.default;
module.exports.default = exports.default;