"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _throttle = _interopRequireDefault(require("lodash/throttle"));
/**
 * @param {function} func
 * @param {number} delay - delay in ms for throttle
 * @param {any[]} deps Array of dependencies for useEffect
 * @return {null}
 */
const useThrottledCallback = function (func, delay) {
  let deps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  const callback = (0, _react.useRef)(null);
  callback.current = func;
  const wrappedRef = (0, _react.useRef)(null);
  if (!wrappedRef.current) {
    wrappedRef.current = (0, _throttle.default)(function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return callback.current?.(...args);
    }, delay);
  }
  (0, _react.useEffect)(() => () => {
    wrappedRef.current?.cancel();
  }, [...deps]);
  return wrappedRef.current;
};
var _default = exports.default = useThrottledCallback;
module.exports = exports.default;
module.exports.default = exports.default;