"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getForwardedComponent = exports.getDisplayName = void 0;
var _react = require("react");
var _jsxRuntime = require("react/jsx-runtime");
/**
 * @function
 * @param {string} wrapper - Wrapper name
 * @param {React.Component} Component - React Component
 * @return {string} Combined string
 */
const getDisplayName = (wrapper, Component) => {
  const name = Component.displayName || Component.name || 'Component';
  return `${wrapper}(${name})`;
};

/**
 * @function
 * @param {string} displayName - Component's displayName
 * @param {React.Component} Component - Target component
 * @return {React.Component} The same component with new displayName and forwardedRef
 */
exports.getDisplayName = getDisplayName;
const getForwardedComponent = (displayName, Component) => {
  const WrappedComponent = (props, ref) => /*#__PURE__*/(0, _jsxRuntime.jsx)(Component, {
    ...props,
    forwardedRef: ref
  });
  WrappedComponent.displayName = displayName;
  return /*#__PURE__*/(0, _react.forwardRef)(WrappedComponent);
};
exports.getForwardedComponent = getForwardedComponent;